# Go API client for openapi

The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [OpenAPI-spec](https://www.openapis.org/) from a remote server, you can easily generate an API client.

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.GoClientCodegen

## Installation

Install the following dependencies:

```shell
go get github.com/stretchr/testify/assert
go get golang.org/x/oauth2
go get golang.org/x/net/context
go get github.com/antihax/optional
```

Put the package under your project folder and add the following in import:

```golang
import "./openapi"
```

## Documentation for API Endpoints

All URIs are relative to *https://api.chat-api.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Class1InstanceApi* | [**Expiry**](docs/Class1InstanceApi.md#expiry) | **Post** /expiry | Updates the QR code after its expired
*Class1InstanceApi* | [**GetQRCode**](docs/Class1InstanceApi.md#getqrcode) | **Get** /qr_code | Direct link to QR-code in the form of an image, not base64.
*Class1InstanceApi* | [**GetSettings**](docs/Class1InstanceApi.md#getsettings) | **Get** /settings | Get settings
*Class1InstanceApi* | [**GetStatus**](docs/Class1InstanceApi.md#getstatus) | **Get** /status | Get the account status and QR code for authorization.
*Class1InstanceApi* | [**Logout**](docs/Class1InstanceApi.md#logout) | **Post** /logout | Logout from WhatsApp Web to get new QR code.
*Class1InstanceApi* | [**Reboot**](docs/Class1InstanceApi.md#reboot) | **Post** /reboot | Reboot your whatsapp instance.
*Class1InstanceApi* | [**Retry**](docs/Class1InstanceApi.md#retry) | **Post** /retry | Repeat the manual synchronization attempt with the device
*Class1InstanceApi* | [**SetSettings**](docs/Class1InstanceApi.md#setsettings) | **Post** /settings | Set settings
*Class1InstanceApi* | [**Takeover**](docs/Class1InstanceApi.md#takeover) | **Post** /takeover | Returns the active session if the device has connected another instance of Web WhatsApp
*Class2MessagesApi* | [**ForwardMessage**](docs/Class2MessagesApi.md#forwardmessage) | **Post** /forwardMessage | Forwarding messages to a new or existing chat.
*Class2MessagesApi* | [**GetMessages**](docs/Class2MessagesApi.md#getmessages) | **Get** /messages | Get a list of messages.
*Class2MessagesApi* | [**SendContact**](docs/Class2MessagesApi.md#sendcontact) | **Post** /sendContact | Sending a contact or contact list to a new or existing chat.
*Class2MessagesApi* | [**SendFile**](docs/Class2MessagesApi.md#sendfile) | **Post** /sendFile | Send a file to a new or existing chat.
*Class2MessagesApi* | [**SendLink**](docs/Class2MessagesApi.md#sendlink) | **Post** /sendLink | Send text with link and link&#39;s preview to a new or existing chat.
*Class2MessagesApi* | [**SendLocation**](docs/Class2MessagesApi.md#sendlocation) | **Post** /sendLocation | Sending a location to a new or existing chat.
*Class2MessagesApi* | [**SendMessage**](docs/Class2MessagesApi.md#sendmessage) | **Post** /sendMessage | Send a message to a new or existing chat.
*Class2MessagesApi* | [**SendPTT**](docs/Class2MessagesApi.md#sendptt) | **Post** /sendPTT | Send a ptt-audio to a new or existing chat.
*Class2MessagesApi* | [**SendVCard**](docs/Class2MessagesApi.md#sendvcard) | **Post** /sendVCard | Sending a vcard to a new or existing chat.
*Class3ChatsApi* | [**AddGroupParticipant**](docs/Class3ChatsApi.md#addgroupparticipant) | **Post** /addGroupParticipant | Adding participant to a group
*Class3ChatsApi* | [**DemoteGroupParticipant**](docs/Class3ChatsApi.md#demotegroupparticipant) | **Post** /demoteGroupParticipant | Demote group participant
*Class3ChatsApi* | [**GetChats**](docs/Class3ChatsApi.md#getchats) | **Get** /dialogs | Get the chat list.
*Class3ChatsApi* | [**Group**](docs/Class3ChatsApi.md#group) | **Post** /group | Creates a group and sends the message to the created group.
*Class3ChatsApi* | [**PromoteGroupParticipant**](docs/Class3ChatsApi.md#promotegroupparticipant) | **Post** /promoteGroupParticipant | Make participant in the group an administrator
*Class3ChatsApi* | [**ReadChat**](docs/Class3ChatsApi.md#readchat) | **Post** /readChat | Open chat for reading messages
*Class3ChatsApi* | [**RemoveGroupParticipant**](docs/Class3ChatsApi.md#removegroupparticipant) | **Post** /removeGroupParticipant | Remove participant from a group
*Class4WebhooksApi* | [**SetWebhook**](docs/Class4WebhooksApi.md#setwebhook) | **Post** /webhook | Sets the URL for receiving webhook
*Class5QueuesApi* | [**ClearActionsQueue**](docs/Class5QueuesApi.md#clearactionsqueue) | **Post** /clearActionsQueue | Clear outbound actions queue.
*Class5QueuesApi* | [**ClearMessagesQueue**](docs/Class5QueuesApi.md#clearmessagesqueue) | **Post** /clearMessagesQueue | Clear outbound messages queue.
*Class5QueuesApi* | [**ShowActionsQueue**](docs/Class5QueuesApi.md#showactionsqueue) | **Get** /showActionsQueue | Get outbound messages queue.
*Class5QueuesApi* | [**ShowMessagesQueue**](docs/Class5QueuesApi.md#showmessagesqueue) | **Get** /showMessagesQueue | Get outbound messages queue.
*Class6BanApi* | [**BanTest**](docs/Class6BanApi.md#bantest) | **Post** /banTest | Test ban settings
*Class6BanApi* | [**GetBanSettings**](docs/Class6BanApi.md#getbansettings) | **Get** /banSettings | Get settings
*Class6BanApi* | [**SetBanSettings**](docs/Class6BanApi.md#setbansettings) | **Post** /banSettings | Set settings
*Class7TestingApi* | [**InstanceStatuses**](docs/Class7TestingApi.md#instancestatuses) | **Get** /instanceStatuses | Returns instance status changes history.
*Class7TestingApi* | [**WebhookStatuses**](docs/Class7TestingApi.md#webhookstatuses) | **Get** /webhookStatus | Returns webhook status for message.


## Documentation For Models

 - [Ack](docs/Ack.md)
 - [BanSettings](docs/BanSettings.md)
 - [BanTestAction](docs/BanTestAction.md)
 - [BanTestStatus](docs/BanTestStatus.md)
 - [Chat](docs/Chat.md)
 - [ChatIdProp](docs/ChatIdProp.md)
 - [ChatUpdate](docs/ChatUpdate.md)
 - [Chats](docs/Chats.md)
 - [ClearActionsQueueStatus](docs/ClearActionsQueueStatus.md)
 - [ClearMessagesQueueStatus](docs/ClearMessagesQueueStatus.md)
 - [CreateGroupAction](docs/CreateGroupAction.md)
 - [CreateGroupStatus](docs/CreateGroupStatus.md)
 - [ForwardMessageRequest](docs/ForwardMessageRequest.md)
 - [GroupParticipantAction](docs/GroupParticipantAction.md)
 - [GroupParticipantStatus](docs/GroupParticipantStatus.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2005Update](docs/InlineResponse2005Update.md)
 - [InlineResponse401](docs/InlineResponse401.md)
 - [InstanceStatus](docs/InstanceStatus.md)
 - [InstanceStatusAction](docs/InstanceStatusAction.md)
 - [InstanceStatusLink](docs/InstanceStatusLink.md)
 - [InstanceStatusStatusData](docs/InstanceStatusStatusData.md)
 - [InstanceStatusStatusDataActions](docs/InstanceStatusStatusDataActions.md)
 - [Message](docs/Message.md)
 - [Messages](docs/Messages.md)
 - [OutboundAction](docs/OutboundAction.md)
 - [OutboundActions](docs/OutboundActions.md)
 - [OutboundMessage](docs/OutboundMessage.md)
 - [OutboundMessages](docs/OutboundMessages.md)
 - [PhoneProp](docs/PhoneProp.md)
 - [ReadChatAction](docs/ReadChatAction.md)
 - [ReadChatStatus](docs/ReadChatStatus.md)
 - [SendContactRequest](docs/SendContactRequest.md)
 - [SendFileRequest](docs/SendFileRequest.md)
 - [SendLinkRequest](docs/SendLinkRequest.md)
 - [SendLocationRequest](docs/SendLocationRequest.md)
 - [SendMessageRequest](docs/SendMessageRequest.md)
 - [SendMessageStatus](docs/SendMessageStatus.md)
 - [SendPttRequest](docs/SendPttRequest.md)
 - [SendVCardRequest](docs/SendVCardRequest.md)
 - [SetWebhookStatus](docs/SetWebhookStatus.md)
 - [Settings](docs/Settings.md)
 - [Status](docs/Status.md)
 - [Statuses](docs/Statuses.md)
 - [WebhookStatus](docs/WebhookStatus.md)
 - [WebhookUrl](docs/WebhookUrl.md)


## Documentation For Authorization



## instanceId

- **Type**: API key

Example

```golang
auth := context.WithValue(context.Background(), sw.ContextAPIKey, sw.APIKey{
    Key: "APIKEY",
    Prefix: "Bearer", // Omit if not necessary.
})
r, err := client.Service.Operation(auth, args)
```


## token

- **Type**: API key

Example

```golang
auth := context.WithValue(context.Background(), sw.ContextAPIKey, sw.APIKey{
    Key: "APIKEY",
    Prefix: "Bearer", // Omit if not necessary.
})
r, err := client.Service.Operation(auth, args)
```


## Author

sale@chat-api.com

