# \Class5QueuesApi

All URIs are relative to *https://api.chat-api.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ClearActionsQueue**](Class5QueuesApi.md#ClearActionsQueue) | **Post** /clearActionsQueue | Clear outbound actions queue.
[**ClearMessagesQueue**](Class5QueuesApi.md#ClearMessagesQueue) | **Post** /clearMessagesQueue | Clear outbound messages queue.
[**ShowActionsQueue**](Class5QueuesApi.md#ShowActionsQueue) | **Get** /showActionsQueue | Get outbound messages queue.
[**ShowMessagesQueue**](Class5QueuesApi.md#ShowMessagesQueue) | **Get** /showMessagesQueue | Get outbound messages queue.



## ClearActionsQueue

> ClearActionsQueueStatus ClearActionsQueue(ctx, )

Clear outbound actions queue.

This method is needed when you accidentally sent thousands of actions in a row.

### Required Parameters

This endpoint does not need any parameter.

### Return type

[**ClearActionsQueueStatus**](ClearActionsQueueStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)


## ClearMessagesQueue

> ClearMessagesQueueStatus ClearMessagesQueue(ctx, )

Clear outbound messages queue.

This method is needed when you accidentally sent thousands of messages in a row.

### Required Parameters

This endpoint does not need any parameter.

### Return type

[**ClearMessagesQueueStatus**](ClearMessagesQueueStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)


## ShowActionsQueue

> OutboundActions ShowActionsQueue(ctx, )

Get outbound messages queue.

When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.

### Required Parameters

This endpoint does not need any parameter.

### Return type

[**OutboundActions**](OutboundActions.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)


## ShowMessagesQueue

> OutboundMessages ShowMessagesQueue(ctx, )

Get outbound messages queue.

When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.

### Required Parameters

This endpoint does not need any parameter.

### Return type

[**OutboundMessages**](OutboundMessages.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)

